/** @file filebox.cpp

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2015.03.21 -

	@brief [ file box ]
*/

#include "filebox.h"
#include "../common.h"

FileBox::FileBox(HWND parent_window)
{
	hWnd = parent_window;
}

FileBox::~FileBox()
{
}


void FileBox::get_parent_dir(_TCHAR *path)
{
	int pt = (int)_tcslen(path);
	while(pt >= 0 && path[pt] != _T('\\')) {
		pt--;
	}
	path[pt + 1] = _T('\0');
}

bool FileBox::Show(const _TCHAR* filter, const _TCHAR *title, const _TCHAR* dir, const _TCHAR* ext, bool save, _TCHAR *path)
{
	_TCHAR tmp[_MAX_PATH] = _T("");
	_TCHAR app[_MAX_PATH];

	OPENFILENAME OpenFileName;
	int rc = 0;

	memset(&OpenFileName, 0, sizeof(OpenFileName));
	OpenFileName.lStructSize = sizeof(OPENFILENAME);
	OpenFileName.hwndOwner = hWnd;
	OpenFileName.lpstrFilter = filter;
	OpenFileName.lpstrFile = tmp;
	OpenFileName.nMaxFile = _MAX_PATH;
	OpenFileName.lpstrTitle = title;
	if(ext != NULL && ext[0]) {
		OpenFileName.lpstrDefExt = ext;
	}
	if(dir != NULL && dir[0]) {
		OpenFileName.lpstrInitialDir = dir;
	} else if (path != NULL && path[0]) {
		_tcscpy(app, path);
		get_parent_dir(app);
		OpenFileName.lpstrInitialDir = app;
	} else {
		GetModuleFileName(NULL, app, _MAX_PATH);
		get_parent_dir(app);
		OpenFileName.lpstrInitialDir = app;
	}
	if (save) {
		OpenFileName.Flags = OFN_OVERWRITEPROMPT;
		rc = GetSaveFileName(&OpenFileName);
	} else {
		OpenFileName.Flags = 0;
		rc = GetOpenFileName(&OpenFileName);
	}

	flags = OpenFileName.Flags;

	if (rc) {
		_tcscpy(path, OpenFileName.lpstrFile);
		return true;
	}
	return false;
}
