/** @file gui.cpp

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2014.03.24 -

	@brief [ gui ]
*/

#include "gui.h"
#include "../config.h"

GUI::GUI(HWND hwnd, HINSTANCE hinst, CFont *new_font, EMU *new_emu)
{
	hWindow = hwnd;
	hInstance = hinst;
	font = new_font;
	emu = new_emu;
	configbox = new ConfigBox(hinst, font, emu, &config);
	keybindbox = new KeybindBox(hinst, font, emu);
	volumebox = new VolumeBox(hinst, font, emu, &config);
	aboutbox = new AboutBox(hinst, font, emu);

}

GUI::~GUI()
{
	delete aboutbox;
	delete volumebox;
	delete keybindbox;
	delete configbox;

}

void GUI::show_config_dialog()
{
	emu->set_pause(1, true);
	if (configbox->Show(hWindow) == IDOK) {
		save_config();
		emu->change_pos_led(config.led_pos);
	}
	emu->set_pause(1, false);
}

void GUI::show_keybind_dialog()
{
	emu->set_pause(1, true);
	if (keybindbox->Show(hWindow) == IDOK) {
		emu->save_keybind();
	}
	emu->set_pause(1, false);
}

void GUI::create_volume_dialog()
{
	// create volume dialog
	volumebox->Create(hWindow);
}

/// create about dialog
void GUI::show_about_dialog()
{
	emu->set_pause(1, true);
	aboutbox->Show(hWindow);
	if(emu) emu->set_pause(1, false);

}
