/** @file gui.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2014.03.24 -

	@brief [ gui ]
*/

#ifndef _GUI_H_
#define _GUI_H_

#include <Windows.h>
#include "../common.h"
#include "../emu.h"
#include "../winfont.h"
#include "configbox.h"
#include "keybindbox.h"
#include "volumebox.h"
#include "aboutbox.h"

class GUI
{
private:
	HWND	  hWindow;
	HINSTANCE hInstance;
	CFont *font;
	ConfigBox *configbox;
	KeybindBox *keybindbox;
	VolumeBox *volumebox;
	AboutBox *aboutbox;

public:
	EMU *emu;

	GUI(HWND hwnd, HINSTANCE hinst, CFont *new_font, EMU *new_emu);
	~GUI();

	void show_config_dialog();
	void show_keybind_dialog();
	void create_volume_dialog();
	void show_about_dialog();
};

#endif /* _GUI_H_ */
