/** @file keybindbox.h

	HITACHI BASIC MASTER LEVEL3 Mark5 Emulator 'EmuB-6892'
	Skelton for retropc emulator

	@author Sasaji
	@date   2012.03.31 -

	@brief [ keybind box ]
*/

#ifndef _KEYBINDBOX_H_
#define _KEYBINDBOX_H_

#include <windows.h>
#include "keybindctrl.h"
#include "dialogbox.h"

#define MAX_TAB_NUM 2
#define MAX_PRESET_NUM	4

class EMU;

/**
	@brief keybind dialog
*/
class KeybindBox : public CDialogBox
{
private:
	KeyBindControl *kbctl[MAX_TAB_NUM];

	UINT16 vmkey_map[MAX_TAB_NUM][KBCTRL_MAX_LINES];
	int    vmkey_map_size[MAX_TAB_NUM];
	UINT32 *vkkey_defmap[MAX_TAB_NUM];
	int     vkkey_defmap_rows[MAX_TAB_NUM];
	int     vkkey_defmap_cols[MAX_TAB_NUM];
	UINT32 *vkkey_map[MAX_TAB_NUM];
	UINT32 *vkkey_preset_map[MAX_TAB_NUM][MAX_PRESET_NUM];

	_TCHAR vm_label[100];
	_TCHAR vk_label[100];
	_TCHAR vj_label[100];

	int selected_tabctrl;

	INT_PTR onInitDialog(UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR onCommand(UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR onNotify(UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR onMouseWheel(UINT message, WPARAM wParam, LPARAM lParam);
//	INT_PTR onControlColorStatic(UINT, WPARAM, LPARAM);
	INT_PTR onClickOk();
	INT_PTR onClickLoadDefault();
	INT_PTR onClickLoadPreset(int idx);
	INT_PTR onClickSavePreset(int idx);

	void select_tabctrl(int tab_num);

public:
	KeybindBox(HINSTANCE, CFont *, EMU *);
	~KeybindBox() {};

	void SetVmKeyMap(int tab_num, UINT16 *vmKeyMap, int size);
	void SetVkKeyDefMap(int tab_num, UINT32 *vkKeyDefMap, int rows, int cols);
	void SetVkKeyMap(int tab_num, UINT32 *vkKeyMap);
	void SetVkKeyPresetMap(int tab_num, UINT32 *vkKeyMap, int idx);
	void SetVmKey(int tab_num, int idx, UINT16 code);
	void SetTitleLabel(_TCHAR *vm, _TCHAR *vk, _TCHAR *vj);
};

#endif
