/** @file utility.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2014.04.01 -

	@brief [ utility ]
*/

#ifndef _UTILITY_H_
#define _UTILITY_H_

#include "common.h"

namespace UTILITY
{
	// ----------------------------------------------------------------------
	// file path conversion

	bool check_file_extension(const _TCHAR *filename, const _TCHAR *ext);

	void convert_path_separator(_TCHAR *path);
	void add_path_separator(_TCHAR *path);

	void get_dir_and_basename(const _TCHAR *path, _TCHAR *dir, _TCHAR *name);
	void get_dir_and_basename(_TCHAR *path, _TCHAR *name);

	_TCHAR *trim_center(const _TCHAR *str, int maxlen);

	bool make_relative_path(const _TCHAR *base_path, _TCHAR *path);
	bool make_absolute_path(const _TCHAR *base_path, _TCHAR *path);

	_TCHAR *slim_path(const _TCHAR *path, int *parent_num = NULL);

	// ----------------------------------------------------------------------
	// string conversion

#ifdef _UNICODE
	/* _UNICODE */

//	bool conv_tchar_to_utf8(const wchar_t *srcStart, int srcMaxSize, char *dstStart, int dstMaxSize);
//	bool conv_utf8_to_tchar(const char *srcStart, int srcMaxSize, wchar_t *dstStart, int dstMaxSize);
	/// native string to UTF-8 string
	wchar_t *wconv_from_native_path(const wchar_t *str, int maxSize = _MAX_PATH);
	/// native string to UTF-8 string
	char    *cconv_from_native_path(const wchar_t *str, int maxSize = _MAX_PATH);
	/// native string to UTF-8 string
	int      wcs_to_mbs(char *dst, const wchar_t *src, int maxSize = _MAX_PATH);
	/// UTF-8 string to native string
	wchar_t *conv_to_native_path(const wchar_t *str, int maxSize = _MAX_PATH);
	/// UTF-8 string to native string
	wchar_t *conv_to_native_path(const char *str, int maxSize = _MAX_PATH);
	/// UTF-8 string to native string
	int      mbs_to_wcs(wchar_t *dst, const char *src, int maxSize = _MAX_PATH);

#define conv_from_native_path wconv_from_native_path

#else	/* !_UNICODE */

//	bool conv_tchar_to_utf8(const char *srcStart, int srcMaxSize, char *dstStart, int dstMaxSize);
//	bool conv_utf8_to_tchar(const char *srcStart, int srcMaxSize, char *dstStart, int dstMaxSize);
	/// native string to UTF-8 string
	char *cconv_from_native_path(const char *str, int maxSize = _MAX_PATH);
	/// native string to UTF-8 string
	int   wcs_to_mbs(char *dst, const char *src, int maxSize = _MAX_PATH);
	/// UTF-8 string to native string
	char *conv_to_native_path(const char *str, int maxSize = _MAX_PATH);
	/// UTF-8 string to native string
	int   mbs_to_wcs(char *dst, const char *src, int maxSize = _MAX_PATH);

#define conv_from_native_path cconv_from_native_path

#endif	/* _UNICODE */

};

#endif /* _UTILITY_H_ */
